/*
 * Analog backend driver
 *
 * Copyright (C) 2005 Mike Neill <mike.neill@philips.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
Rev Date       Author      Comments
--------------------------------------------------------------------------------
  1            neill
002 20051123   raiyat      Linux 2.6.14.2 changes
003 20060908   laird       Linux 2.6.17.7 changes

 */
#ifndef __ANALOG_BACKEND_H__
#define __ANALOG_BACKEND_H__

#include <linux/device.h>

extern struct class *ana_backend_get_class(void);
extern struct class_device *ana_backend_device_create(struct class *cls,
                                                      struct class_device *parent,
                                                      dev_t devt,
                                                      struct device *device,
                                                      char *devname);
extern void ana_backend_device_remove(struct class *cls,
                                      dev_t devt);

#endif /* __ANALOG_BACKEND_H__ */
